#!/bin/env python

import unittest
import pycontrol

try:
    from pycontrol.pycontrol import BIGIP
except: print "pycontrol import failed!" 

USER = 'admin'
PASS = 'admin'
HOST1 = '10.100.100.245'
HOST2 = '192.168.1.245'
DIR = 'c:\\tmp\\'
WSDL = ['System.SystemInfo','LocalLB.Pool']

class TestBasic(unittest.TestCase):

    def testcreateClient(self):
        '''this also tests directory kwarg'''
        self.b = BIGIP(hostname=HOST1, username=USER, password=PASS, directory=DIR, wsdls=WSDL)
        self.assert_(isinstance(self.b, pycontrol.pycontrol.BIGIP))
        del(self.b)

    def testFromUrl(self):
        self.c = BIGIP(hostname=HOST1, username=USER, password=PASS, fromurl=True, wsdls=WSDL)
        self.assert_(isinstance(self.c, pycontrol.pycontrol.BIGIP))
        del(self.c)
    
    def testBasicCall(self):
        self.c = BIGIP(hostname=HOST1, username=USER, password=PASS, fromurl=True, wsdls=WSDL)
        self.ver = self.c.System.SystemInfo.get_version()
        self.assert_(self.ver)
        del(self.c)

    def testPoolList(self):
        self.c = BIGIP(hostname=HOST1, username=USER, password=PASS,
                fromurl=True, wsdls=['LocalLB.Pool'])
        self.pools = self.c.LocalLB.Pool.get_list()
        self.assert_(self.pools)
        del(self.c)

    def testMultipoint(self):
        self.c = BIGIP(hostname=HOST1, username=USER, password=PASS,
                directory=DIR, wsdls=['LocalLB.Pool'])

        self.pools_1 = self.c.LocalLB.Pool.get_list()
        url2 = 'https://'+HOST2+'/iControl/iControlPortal.cgi'
        self.c.LocalLB.Pool.suds.set_options(location=url2)
        self.pools_2 = self.c.LocalLB.Pool.get_list()
        self.assert_(self.pools_1 == self.pools_2)
        del(self.c)


if __name__ == '__main__':
    
    unittest.main()
